
<style>
.infinite-page:not(.no-thing-box-grid), .thing-box-grid {
    display: grid;
    grid-template-columns: repeat(auto-fill,minmax(230px,1fr))!important;
    grid-gap: 10px;
    margin: 5px 5px 10px;
}
</style> 

<?php
// Database configuration
$host = $_AVOS['config']['mysql']['hostname'];
$username = $_AVOS['config']['mysql']['username'];
$password = $_AVOS['config']['mysql']['password'];
$database = $_AVOS['config']['mysql']['database'];

// Establish database connection
$conn = new mysqli($host, $username, $password, $database);
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Function to check if a photo is already a favorite for a user
function isPhotoFavorite($conn, $user_id, $photoId) {
    $sql = "SELECT COUNT(*) AS count FROM userFavoritesPhotos WHERE user_idPhotos = $user_id AND photos_id = $photoId";
    $result = $conn->query($sql);

    if ($result && $result->num_rows > 0) {
        $row = $result->fetch_assoc();
        return intval($row['count']) > 0;
    }

    return false; // If query fails or no rows found
}

// Handle adding/removing photos to/from favorites
if (isset($_POST['action']) && isset($_POST['photoId'])) {
    $photoId = $_POST['photoId'];
    $user_id = $_SESSION['user_id']; // Assuming you have the user's session ID available

    if ($_POST['action'] === 'add') {
        if (isPhotoFavorite($conn, $user_id, $photoId)) {
            echo "Photo is already a favorite";
        } else {
            // Add the photo to favorites
            $sql = "INSERT INTO userFavoritesPhotos (user_idPhotos, photos_id) VALUES ($user_id, $photoId)";
            if ($conn->query($sql) === TRUE) {
                echo "Photo added to favorites successfully";
            } else {
                echo "Error adding photo to favorites: " . $conn->error;
            }
        }
    } elseif ($_POST['action'] === 'remove') {
        // Remove the photo from favorites
        $sql = "DELETE FROM userFavoritesPhotos WHERE user_idPhotos = $user_id AND photos_id = $photoId";
        if ($conn->query($sql) === TRUE) {
            echo "Photo removed from favorites successfully";
        } else {
            echo "Error removing photo from favorites: " . $conn->error;
        }
    }
}
?>



<div class="empty-class">
    <h3 class="photos-album">Photos Gallery Albums</h3>
    <div class="thing-box-container thing-box-grid mlr0">
        <?php foreach ($photos as $p): ?>
        <div class="box album loaded" data-synced-purchases-target="" data-id="<?= $p['id'] ?>">
            <a href="<?= encodeUrl('photosGallery', $p) ?>" class="media-container shadow">
                <span class="marquee album-title album-title-bottom">
                    <span>  <?= ucfirst($p['title']) ?> <i class="fa fa-eye text-white" aria-hidden="true"></i> <?= $p['views'] ?></span>
                </span>
                <div class="indicators-top-right flex">
                    <span><i class="fa fa-picture-o" aria-hidden="true"></i><?= $p['numPhotos'] ?></span>
                </div>
                <img 
  class="default-thumbnail" 
  data-type="Image" 
  importance="high" 
  loading="lazy" 
  src="<?= $p['imagePath'] ?><?= $p['mainPhoto'] ?>.jpg" 
  alt="<?= $p['description'] ?>" 
  title="<?= $p['title'] ?>" 
  decoding="async" 
  fetchpriority="high"
  aria-label="<?= $p['description'] ?>" 
  role="img">

            </a>
            <?php if (isset($userUse) && $userUse > 0): ?>
            <button class="btn btn-grey btn-sm follow-button" data-action="add" data-photoId="<?= $p['id'] ?>">
    <?php if (isPhotoFavorite($conn, $user_id, $p['id'])): ?>
        <i class="fa fa-heart"></i> <!-- Filled heart icon for favorite photos -->
    <?php else: ?>
        <i class="fa fa-heart-o"></i> <!-- Empty heart icon for non-favorite photos -->
    <?php endif; ?>
</button>
<?php endif; ?>
        </div>
        <?php endforeach; ?>
    </div>
</div>

<script>
$(document).ready(function() {
    $('.follow-button').click(function() {
        var action = $(this).data('action');
        var photoId = $(this).data('photoid');
        var button = $(this);

        if (action === 'add') {
            addToFavorites(photoId, button);
        } else if (action === 'remove') {
            removeFromFavorites(photoId, button);
        }
    });

    function addToFavorites(photoId, button) {
        $.post("", { action: "add", photoId: photoId }, function(data) {
            console.log(data);
            updateButtonStatus(button, true);
        });
    }

    function removeFromFavorites(photoId, button) {
        $.post("", { action: "remove", photoId: photoId }, function(data) {
            console.log(data);
            updateButtonStatus(button, false);
        });
    }

    function updateButtonStatus(button, isAdded) {
        if (isAdded) {
            button.data('action', 'remove');
            button.find('i').removeClass('fa-heart-o').addClass('fa-heart');
        } else {
            button.data('action', 'add');
            button.find('i').removeClass('fa-heart').addClass('fa-heart-o');
        }
    }
});


</script>




<br />


  <? if (!isset($_GET['layout']) || $url['page'] == 1 || $page == 1): ?>

  <? endif; ?>

  <? if (!empty($paginationLoadMore) && $pages > 1 && $page == 1): ?>
      <div class="item-more" id="loadmore" style="text-align: center;">
          <a href="javascript:page.loadMore();" class="btn btn-theme"><?= $paginationMoreBtnText ?></a>
      </div>
  <? endif; ?>

  <? if (empty($paginationLoadMore)): ?>
      <div class="item-more" id="loadmore" style="text-align: center;">
          <? if ($page > 1): ?>
              <a href="javascript:document.location=page.getPrevPage();" class="btn btn-theme pagestyle"><?= $paginationBackBtnText ?></a>
          <? endif; ?>
          <? if ($page < $pages): ?>
              <a href="javascript:document.location=page.getNextPage();" class="btn btn-theme pagestyle"><?= $paginationNextBtnText ?></a>
          <? endif; ?>
      </div>
  <? endif; ?>

  <? if (!isset($_GET['layout']) || $url['page'] == 1): ?>
  <? endif; ?>





